'ping_Voltm4.bas
'2-Kanal-Messung an ADC6 bzw. an ADC7
'Spanungswerte  werden als Dezimalwerte angezeigt
'Darstellung der Spannung mit zwei Kommastellen
'Maximalwert hngt von Vcc ab, bei 4,5 V Betriebsspannung: 3,6V
'Bei Schaltung mit Messbereichserweiterung grter Anzeigewert: 9,99V
'Hermann Nieder
$crystal = 8000000
$regfile = "m8def.dat"
$hwstack = 64
$swstack = 64
$framesize = 64

Dim Leds(12) As Word
Dim W As Word
Dim D As Byte
Dim N As Word

Dim X As Byte
Dim Y As Byte
Dim Dat As Long
Dim Dats As Long
Dim Adcw As Long
Dim Z As Word
Dim Datb As Byte
Dim R_einer As Long
Dim R_einer1 As Long
Dim R_zehnt As Word
Dim R_zehnt1 As Word
Dim R_hundert As Word
Dim R_hundert1 As Word
Dim Zeichen As Word
Dim Splt1 As Byte
Dim Splt2 As Byte
Dim Splt3 As Byte
Dim Splt4 As Byte
Dim Kanal As Bit


Declare Sub Initialisierung

Declare Sub Led1(byval X As Byte , Byval Y As Byte)
Declare Sub Led0(byval X As Byte , Byval Y As Byte)



Initialisierung

Dim Xx As Single
Dim Yy As Single



Kanal = 0
Portb.7 = 0
Portb.6 = 1

Do
If Kanal = 0 Then
Gosub Messen6
End If
If Kanal = 1 Then
Gosub Messen7
End If
Loop

Messen6:
'Kanalanzeige durch Led
Portb.7 = 0
Portb.6 = 1
Dat = Getadc(6)
Gosub Messen
Return

Messen7:
'Kanalanzeige durch Led
Portb.6 = 0
Portb.7 = 1
Dat = Getadc(7)
Gosub Messen
Return

Messen:

'Schritt 1: Dat * 41 ( = 10*4,1, gemessener Betrag von Vcc bei
'Betriebsspannung von 5V, bei Betrieb mit Batterien kleinerer Wert!)
Dat = Dat * 36
'bei Zusatzschaltung mit Spannungsteiler Uadc=Ue/3 folgende
'Programmzeile einfgen
'Dat = Dat * 3
'Schritt 2: Division durch 10230
R_einer = Dat / 10230
Zeichen = R_einer
Gosub Darstellung1

R_einer1 = R_einer * 10230
R_zehnt = Dat - R_einer1

'Schritt 3: mit 10 multiplizieren und dann durch 10230 teilen

R_zehnt = R_zehnt / 1023
Zeichen = R_zehnt
Gosub Darstellung2

R_zehnt1 = R_zehnt * 1023
R_zehnt1 = R_zehnt - R_zehnt1
'Schritt 4: mit 10 multiplizieren und dann durch 1023 teilen
R_zehnt1 = R_zehnt1 * 10
R_hundert = R_zehnt1 / 1023
Zeichen = R_hundert
Gosub Darstellung3
Waitms 1000
Return


'Zeichen links
Darstellung1:
Gosub Zeichen_z
Leds(1) = Splt1
Leds(2) = Splt2
Leds(3) = Splt3
'LEDs(4) = 384 steht fr ein Komma
Leds(4) = 384
Return
'Zeichen Mitte
Darstellung2:
Gosub Zeichen_z
Leds(5) = Splt1
Leds(6) = Splt2
Leds(7) = Splt3
Leds(8) = Splt4
Return
'Zeichen rechts
Darstellung3:
Gosub Zeichen_z
Leds(9) = Splt1
Leds(10) = Splt2
Leds(11) = Splt3
Leds(12) = Splt4
Return

Zeichen_z:
'Fallunterscheidung fr Muster der Zeichen 0..9
Select Case Zeichen
Case 0:
Splt1 = 124
Splt2 = 68
Splt3 = 124
Splt4 = 0
Case 1:
Splt1 = 0
Splt2 = 8
Splt3 = 124
Splt4 = 0
Case 2:
Splt1 = 116
Splt2 = 84
Splt3 = 92
Splt4 = 0
Case 3:
Splt1 = 84
Splt2 = 84
Splt3 = 124
Splt4 = 0

Case 4:
Splt1 = 28
Splt2 = 16
Splt3 = 124
Splt4 = 0
Case 5:
Splt1 = 92
Splt2 = 84
Splt3 = 116
Splt4 = 0
Case 6:
Splt1 = 124
Splt2 = 84
Splt3 = 116
Splt4 = 0

Case 7:
Splt1 = 4
Splt2 = 4
Splt3 = 124
Splt4 = 0
Case 8:
Splt1 = 124
Splt2 = 84
Splt3 = 124
Splt4 = 0
Case 9:
Splt1 = 92
Splt2 = 84
Splt3 = 124
Splt4 = 0
End Select

Return


Sub Led1(byval X As Byte , Byval Y As Byte)
 If X < 13 Then
  Select Case Y
    Case 1 : Leds(x).9 = 1
    Case 2 : Leds(x).8 = 1
    Case 3 : Leds(x).7 = 1
    Case 4 : Leds(x).6 = 1
    Case 5 : Leds(x).5 = 1
    Case 6 : Leds(x).4 = 1
    Case 7 : Leds(x).3 = 1
    Case 8 : Leds(x).2 = 1
    Case 9 : Leds(x).1 = 1
    Case 10 : Leds(x).0 = 1
   End Select
  End If
End Sub

Sub Led0(byval X As Byte , Byval Y As Byte)
 If X < 13 Then
  Select Case Y
    Case 1 : Leds(x).9 = 0
    Case 2 : Leds(x).8 = 0
    Case 3 : Leds(x).7 = 0
    Case 4 : Leds(x).6 = 0
    Case 5 : Leds(x).5 = 0
    Case 6 : Leds(x).4 = 0
    Case 7 : Leds(x).3 = 0
    Case 8 : Leds(x).2 = 0
    Case 9 : Leds(x).1 = 0
    Case 10 : Leds(x).0 = 0
   End Select
  End If
End Sub


'******************  Service-Unterprogramme *********************


Sub Initialisierung
  Config Portc = &B0011111                                  'gendert gegenber Vorlage
  Ddrb = &B11111111                                         'gendert gegenber Vorlage
  Ddrd = &B11111010                                         'Portd.2 -> Eingang
  'Config Portd = &B1111111
  Config Timer2 = Timer , Prescale = 8
  On Ovf2 Tim2_isr
  Enable Timer2
  Enable Interrupts
  Start Timer2

  Config Adc = Single , Prescaler = 64 , Reference = Off
  Start Adc

  'Portd.2 = 1
  Config Int0 = Falling
  Enable Int0
  On Int0 Int_isr
End Sub


Int_isr:
Kanal = Not Kanal
Return



'******************************* Interrupt - Display ****************************

Dim Vy As Byte
Dim Col As Byte
Dim Portdout As Byte
Dim Portcout As Byte
Dim Portbout As Byte

Tim2_isr:
 '800 s
'Timer2 = 56
Col = Col + 1
If Col = 13 Then Col = 1
Vy = Col + 0
Portd = 0
Portbout = &B00000000                                       '
Portb = Portbout
Portcout = &B00000000                                       '
Portc = Portcout
If Col = 1 Then Portb.4 = 0 Else Portb.4 = 1
Portb.3 = 1                                                 'cl
Portb.3 = 0
Portb.2 = 1                                                 'Str
Portb.2 = 0
Portdout = Low(leds(vy))
Portcout = Portdout And &B00111111                          '
Portdout = Portdout And &B11110110                          '
Portd = Portdout
Portc = Portcout
Portbout = High(leds(vy))                                   'And &B11111111                    'gendert
Portb = Portbout                                            'gendert
'Waitms 500
Return

End